# coding: utf-8

"""
    Developer API - URLR

    API powering the features of URLR.

    The version of the OpenAPI document: 0.2
    Contact: contact@urlr.me
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
from typing_extensions import Annotated
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ReduceLinkRequest(BaseModel):
    """
    ReduceLinkRequest
    """ # noqa: E501
    url: StrictStr = Field(description="The url to reduce")
    team: StrictStr = Field(description="Team id (displayed on dashboard)")
    folder: Optional[StrictStr] = Field(default=None, description="Folder id (displayed on dashboard)")
    code: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Custom code")
    label: Optional[StrictStr] = Field(default=None, description="Link label")
    password: Optional[StrictStr] = Field(default=None, description="Link password")
    expired_at: Optional[StrictStr] = Field(default=None, description="Expiration date")
    __properties: ClassVar[List[str]] = ["url", "team", "folder", "code", "label", "password", "expired_at"]

    @field_validator('code')
    def code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[a-zA-Z0-9!-]{3,50}$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9!-]{3,50}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ReduceLinkRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ReduceLinkRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "url": obj.get("url"),
            "team": obj.get("team"),
            "folder": obj.get("folder"),
            "code": obj.get("code"),
            "label": obj.get("label"),
            "password": obj.get("password"),
            "expired_at": obj.get("expired_at")
        })
        return _obj


